/*
* this file is part of the oxygen gtk engine
* Copyright (c) 2012 Hugo Pereira Da Costa <hugo.pereira@free.fr>
*
* This  library is free  software; you can  redistribute it and/or
* modify it  under  the terms  of the  GNU Lesser  General  Public
* License  as published  by the Free  Software  Foundation; either
* version 2 of the License, or(at your option ) any later version.
*
* This library is distributed  in the hope that it will be useful,
* but  WITHOUT ANY WARRANTY; without even  the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License  along  with  this library;  if not,  write to  the Free
* Software Foundation, Inc., 51  Franklin St, Fifth Floor, Boston,
* MA 02110-1301, USA.
*/

#include "oxygenobjectcounter.h"
#include "oxygenobjectcountermap.h"

namespace Oxygen
{
    //____________________________________________________________
    ObjectCounter::ObjectCounter( const std::string& name ):
        count_( 0 )
    {
        count_ = ObjectCounterMap::get().counter( name );
        ObjectCounterMap::get().increment( *count_ );
        return;
    }

    //____________________________________________________________
    ObjectCounter::ObjectCounter( const ObjectCounter& counter ):
        count_( counter.count_ )
    {
        ObjectCounterMap::get().increment( *count_ );
        return;
    }

    //____________________________________________________________
    ObjectCounter::~ObjectCounter( void )
    { if( count_ ) ObjectCounterMap::get().decrement( *count_ ); }

    //____________________________________________________________
    int ObjectCounter::count( void ) const
    { return (count_) ? *count_:0; }

}
